package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.organization.OrganizationDTO;
import cn.com.tenlion.systembase.pojo.vos.organization.OrganizationVO;
import cn.com.tenlion.systembase.service.organization.IOrganizationService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0015 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IOrganizationService organizationService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0015() {}

    @KafkaListener(topics = "C0015FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<OrganizationDTO> organizationDTOList = organizationService.list(params);
        System.out.println(organizationDTOList.size());
        if(null != organizationDTOList && organizationDTOList.size() > 0) {
            for(OrganizationDTO organizationDTO: organizationDTOList) {
                OrganizationVO organizationVO = setData(organizationDTO);
                organizationService.saveKafka(organizationDTO.getOrganizationId(), organizationVO);
            }
        }
    }

    @KafkaListener(topics = "C0015")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            OrganizationDTO organizationDTO = organizationService.get(jsonObject.getString("uid"));
            OrganizationVO organizationVO = setData(organizationDTO);
            organizationService.saveKafka(organizationDTO.getOrganizationId(), organizationVO);
        }else {
            organizationService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private OrganizationVO setData(OrganizationDTO organizationDTO) {
        if(null == organizationDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        OrganizationVO organizationVO = new OrganizationVO();
        organizationVO.setOrganizationName(organizationDTO.getOrganizationName());
        organizationVO.setOrganizationTypeName(organizationDTO.getOrganizationTypeName());
        organizationVO.setAreaCode(organizationDTO.getAreaCode());
        organizationVO.setOrganizationLng(organizationDTO.getOrganizationLng());
        organizationVO.setOrganizationLat(organizationDTO.getOrganizationLat());
        organizationVO.setGridName(organizationDTO.getGridName());
        organizationVO.setGridCode(organizationDTO.getGridCode());
        return organizationVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}